/* sf17r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__17 = 17;

/* Subroutine */ int sf17r_c(real *x, real *berd, real *beid, real *akerd,
        real *akeid, integer *ierr)
{
    /* Initialized data */

    static real ten = 10.f;
    static real e4[9] = { -2.69e-8f,-8.83e-8f,-6.992e-7f,-2.0042e-6f,7.9e-9f,
            7.25179e-5f,.001171874f,.0265165f,0.f };
    static real sys005 = 1.570796f;
    static real sys003 = 6.283185f;
    static real sys011 = .3926991f;
    static real sys029 = .7071068f;
    static real sys001 = 3.141593f;
    static real sys039 = .5772157f;
    static real zmax = 119.f;
    static real sys059 = 3.4e38f;
    static real zero = 0.f;
    static real half = .5f;
    static real d1[9] = { -1.250605e-6f,1.701453e-4f,-.0137246f,.623473f,
            -14.48452f,150.1755f,-565.1403f,542.5347f,-62.5f };
    static real d2[9] = { 1.522699e-5f,-.00163311f,.09991471f,-3.291935f,
            52.14426f,-336.3931f,678.1684f,-260.4167f,5.f };
    static real d3[9] = { 5.232943e-5f,-.005418856f,.317742f,-9.94124f,
            147.5145f,-872.2191f,1548.485f,-477.4306f,5.f };
    static real d4[9] = { 4.368205e-6f,-5.752042e-4f,.04462639f,-1.934767f,
            42.42469f,-408.1555f,1384.594f,-1130.281f,93.75f };
    static real e3[9] = { -5.63e-8f,-1.671e-7f,-1.47e-8f,1.978e-6f,
            1.44255e-5f,7.25024e-5f,-8e-10f,-.0265165f,1.f };

    /* Builtin functions */
    double log(doublereal), sin(doublereal), cos(doublereal), exp(doublereal),
             sqrt(doublereal);

    /* Local variables */
    static real akei, aker;
    extern /* Subroutine */ int sf16r_c(real *, real *, real *, real *, real *,
             integer *);
    static integer i__;
    static real u, v, z__;
    extern /* Subroutine */ int utsf10_c(integer *, integer *);
    static real b1, b2, b3, b4, z3, z4, dc, de, ds, um, vm, zi, r1p, r2p, bei,
             dcm, ber, arg, con, dsm, dsq, zim, zsq;

    *ierr = 0;
    sf16r_c(x, &ber, &bei, &aker, &akei, ierr);
    z__ = abs(*x);
    if (z__ > ten) {
        goto L3;
    }
    if (z__ == zero) {
        goto L2;
    }
    z__ /= ten;
    zsq = z__ * z__;
    z3 = zsq * z__;
    z4 = zsq * zsq;
    b1 = d1[0];
    b2 = d2[0];
    b3 = d3[0];
    b4 = d4[0];
    for (i__ = 2; i__ <= 9; ++i__) {
        b1 = b1 * z4 + d1[i__ - 1];
        b2 = b2 * z4 + d2[i__ - 1];
        b3 = b3 * z4 + d3[i__ - 1];
        b4 = b4 * z4 + d4[i__ - 1];
/* L1: */
    }
    *berd = b1 * z3;
    *beid = z__ * b2;
    if (*x < zero) {
        goto L6;
    }
    r1p = z__ * b3;
    r2p = z3 * b4;
    con = (real)log((real)(*x * half)) + sys039;
    v = abs(*x);
    *akeid = -sys005 * half * *berd + (r1p - *beid * con - bei / v);
    *akerd = sys005 * half * *beid - (r2p + *berd * con + ber / v);
    goto L9;
L2:
    *berd = zero;
    *beid = zero;
    *akeid = zero;
    *akerd = -sys059;
    goto L9;
L3:
    if (z__ > zmax) {
        goto L5;
    }
    zi = ten / z__;
    zim = -zi;
    u = e3[0];
    um = u;
    v = e4[0];
    vm = v;
    for (i__ = 2; i__ <= 9; ++i__) {
        u = u * zi + e3[i__ - 1];
        v = v * zi + e4[i__ - 1];
        um = um * zim + e3[i__ - 1];
        vm = vm * zim + e4[i__ - 1];
/* L4: */
    }
    arg = z__ * sys029;
    ds = (real)sin((real)(arg - sys011));
    dc = (real)cos((real)(arg - sys011));
    dsm = (real)sin((real)(arg + sys011));
    dcm = (real)cos((real)(arg + sys011));
    de = (real)exp(arg);
    dsq = (real)sqrt((real)(sys003 * z__));
    *berd = de * (u * dcm - v * dsm) / dsq;
    *beid = de * (v * dcm + u * dsm) / dsq;
    if (*x < zero) {
        goto L6;
    }
    *akeid = -sys001 * (vm * dc - um * ds) / (de * dsq);
    *akerd = -sys001 * (um * dc + vm * ds) / (de * dsq);
    goto L9;
L5:
    *berd = zero;
    *beid = zero;
    *ierr = 66;
    if (*x < zero) {
        goto L7;
    }
    *akeid = zero;
    *akerd = zero;
    goto L8;
L6:
    *ierr = 1;
    *berd = -(*berd);
    *beid = -(*beid);
L7:
    *akerd = sys059;
    *akeid = sys059;
    if (*ierr == 0) {
        goto L9;
    }
L8:
    utsf10_c(ierr, &c__17);
L9:
    return 0;
} /* sf17r_c */
